<?php
/**
 * 2026 Paysera
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Academic Free License (AFL 3.0)
 * that is bundled with this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://opensource.org/licenses/afl-3.0.php
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * @author Paysera <plugins@paysera.com>
 * @copyright 2026 Paysera
 * @license http://opensource.org/licenses/afl-3.0.php Academic Free License (AFL 3.0)
 * International Registered Trademark & Property of Paysera
 */

declare(strict_types=1);

namespace Paysera\PrestashopPayments\Dto;

if (!defined('_PS_VERSION_')) {
    exit;
}

class PayseraPayment
{
    public function __construct(
        private int $orderId,
        private ?string $payseraPaymentId = null,
        private ?string $payseraOrderId = null,
        private ?string $paymentLink = null,
        private ?int $originalAmount = null,
        private ?string $originalCurrency = null,
        private ?int $paidAmount = null,
        private ?string $paidCurrency = null,
        private ?string $payerName = null,
        private ?string $payerEmail = null,
        private ?string $paymentMethod = null,
        private ?string $status = null
    ) {
    }

    public function getOrderId(): int
    {
        return $this->orderId;
    }

    public function getPayseraPaymentId(): ?string
    {
        return $this->payseraPaymentId;
    }

    public function getPayseraOrderId(): ?string
    {
        return $this->payseraOrderId;
    }

    public function getPaymentLink(): ?string
    {
        return $this->paymentLink;
    }

    public function getOriginalAmount(): ?int
    {
        return $this->originalAmount;
    }

    public function getOriginalCurrency(): ?string
    {
        return $this->originalCurrency;
    }

    public function getPaidAmount(): ?int
    {
        return $this->paidAmount;
    }

    public function getPaidCurrency(): ?string
    {
        return $this->paidCurrency;
    }

    public function getPayerName(): ?string
    {
        return $this->payerName;
    }

    public function getPayerEmail(): ?string
    {
        return $this->payerEmail;
    }

    public function getPaymentMethod(): ?string
    {
        return $this->paymentMethod;
    }

    public function getStatus(): ?string
    {
        return $this->status;
    }
}
